/*
                           ....::::: In The Name Of GOD :::::....

    TFT LCD (ILI9325-ILI9320 LCD Driver) Functions
    By ESMAEIL  TAHERI      1390/09/16
 //======================================================================================================================
ATTENTION:    
    DAR IN LIBRARY ELZAMIST KE DAR EBTEDAYE BARNAME   AZ   #DEFINE LANDSCAPE   YA   #DEFINE PORTRAIT ESTEFADE GARDAD
//=======================================================================================================================

*/
#ifndef         _TFT_LCD_H_
#define        _TFT_LCD_H_ 
#define          HIGH                            1
#define           LOW                          0
//-------------------------------------------------------------------------
#ifndef        LCD_DATA_MSB_PORT
#define        LCD_DATA_MSB_PORT                0
#endif
#ifndef        LCD_DATA_MSB_PORT_OFFSET
#define        LCD_DATA_MSB_PORT_OFFSET          15
#endif
#define          LCD_DATAPORT_MSB_INPUT             GPIO_SetDir(LCD_DATA_MSB_PORT , 0xff<<LCD_DATA_MSB_PORT_OFFSET , 0)
#define          LCD_DATAPORT_MSB_OUTPUT            GPIO_SetDir(LCD_DATA_MSB_PORT , 0xff<<LCD_DATA_MSB_PORT_OFFSET , 1)
#define        LCD_DATAPORT_MSB_PIN               GPIO_ReadValue(LCD_DATA_MSB_PORT)>> LCD_DATA_MSB_PORT_OFFSET
#define        LCD_DATAPORT_MSB_SET(x)            GPIO_SetValue(LCD_DATA_MSB_PORT,x<<LCD_DATA_MSB_PORT_OFFSET)
#define        LCD_DATAPORT_MSB_CLEAR(x)          GPIO_ClearValue(LCD_DATA_MSB_PORT,x<<LCD_DATA_MSB_PORT_OFFSET)
//-------------------------------------------------------------------------
#ifndef        LCD_DATA_LSB_PORT
#define        LCD_DATA_LSB_PORT            0
#endif
#ifndef        LCD_DATA_LSB_PORT_OFFSET
#define        LCD_DATA_LSB_PORT_OFFSET      0
#endif
#define          LCD_DATAPORT_LSB_INPUT           GPIO_SetDir(LCD_DATA_LSB_PORT , 0xff<<LCD_DATA_LSB_PORT_OFFSET , 0)
#define          LCD_DATAPORT_LSB_OUTPUT          GPIO_SetDir(LCD_DATA_LSB_PORT , 0xff<<LCD_DATA_LSB_PORT_OFFSET , 1)
#define        LCD_DATAPORT_LSB_PIN              GPIO_ReadValue(LCD_DATA_LSB_PORT)>> LCD_DATA_LSB_PORT_OFFSET
#define        LCD_DATAPORT_LSB_SET(x)          GPIO_SetValue(LCD_DATA_LSB_PORT , x<<LCD_DATA_LSB_PORT_OFFSET )
#define        LCD_DATAPORT_LSB_CLEAR(x)        GPIO_ClearValue(LCD_DATA_LSB_PORT , x<<LCD_DATA_LSB_PORT_OFFSET )
//------------------------------------------------------------------------
#ifndef       LCD_CONTROL_PORT
#define       LCD_CONTROL_PORT      2
#endif
#ifndef       LCD_CS
#define       LCD_CS            0
#endif
#ifndef       LCD_RS      
#define       LCD_RS            1
#endif
#ifndef      LCD_WR
#define       LCD_WR             2
#endif
#ifndef      LCD_RD
#define       LCD_RD            3
#endif
#ifndef       LCD_RST      
#define       LCD_RST             4
#endif
#define    RST_LOW                   GPIO_ClearValue(LCD_CONTROL_PORT , 1<< LCD_RST)
#define    RST_HIGH                     GPIO_SetValue(LCD_CONTROL_PORT , 1<< LCD_RST)
#define    RS_LOW                      GPIO_ClearValue(LCD_CONTROL_PORT , 1<< LCD_RS)
#define    RS_HIGH                      GPIO_SetValue(LCD_CONTROL_PORT , 1<< LCD_RS)
#define    CS_LOW                      GPIO_ClearValue(LCD_CONTROL_PORT , 1<< LCD_CS)
#define    CS_HIGH                    GPIO_SetValue(LCD_CONTROL_PORT , 1<< LCD_CS)
#define    RD_LOW                    GPIO_ClearValue(LCD_CONTROL_PORT , 1<< LCD_RD)
#define    RD_HIGH                     GPIO_SetValue(LCD_CONTROL_PORT , 1<< LCD_RD)
#define    WR_LOW                      GPIO_ClearValue(LCD_CONTROL_PORT , 1<< LCD_WR)
#define    WR_HIGH                       GPIO_SetValue(LCD_CONTROL_PORT , 1<< LCD_WR)
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------   
#define LCD_DATAPORT_CLEAR           LCD_DATAPORT_MSB_CLEAR(0xFF);LCD_DATAPORT_LSB_CLEAR(0xFF)
#define LCD_DATAPORT_INPUT           LCD_DATAPORT_LSB_INPUT;LCD_DATAPORT_MSB_INPUT
#define LCD_DATAPORT_OUTPUT          LCD_DATAPORT_LSB_OUTPUT;LCD_DATAPORT_MSB_OUTPUT
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#define TS_INS_START_OSC             0x00
#define TS_INS_DRIV_OUT_CTRL         0x01
#define TS_INS_DRIV_WAV_CTRL         0x02
#define TS_INS_ENTRY_MOD             0x03
#define TS_INS_RESIZE_CTRL           0x04
#define TS_INS_DISP_CTRL1            0x07
#define TS_INS_DISP_CTRL2            0x08
#define TS_INS_DISP_CTRL3            0x09
#define TS_INS_DISP_CTRL4            0x0A
#define TS_INS_RGB_DISP_IF_CTRL1     0x0C
#define TS_INS_FRM_MARKER_POS        0x0D
#define TS_INS_RGB_DISP_IF_CTRL2     0x0F
#define TS_INS_POW_CTRL1             0x10
#define TS_INS_POW_CTRL2             0x11
#define TS_INS_POW_CTRL3             0x12
#define TS_INS_POW_CTRL4             0x13
#define TS_INS_GRAM_HOR_AD           0x20
#define TS_INS_GRAM_VER_AD           0x21
#define TS_INS_RW_GRAM               0x22
#define TS_INS_POW_CTRL7             0x29
#define TS_INS_FRM_RATE_COL_CTRL     0x2B
#define TS_INS_GAMMA_CTRL1           0x30
#define TS_INS_GAMMA_CTRL2           0x31
#define TS_INS_GAMMA_CTRL3           0x32
#define TS_INS_GAMMA_CTRL4           0x35 
#define TS_INS_GAMMA_CTRL5           0x36
#define TS_INS_GAMMA_CTRL6           0x37
#define TS_INS_GAMMA_CTRL7           0x38
#define TS_INS_GAMMA_CTRL8           0x39
#define TS_INS_GAMMA_CTRL9           0x3C
#define TS_INS_GAMMA_CTRL10          0x3D
#define TS_INS_HOR_START_AD          0x50
#define TS_INS_HOR_END_AD            0x51
#define TS_INS_VER_START_AD          0x52
#define TS_INS_VER_END_AD            0x53
#define TS_INS_GATE_SCAN_CTRL1       0x60
#define TS_INS_GATE_SCAN_CTRL2       0x61
#define TS_INS_GATE_SCAN_CTRL3       0x6A
#define TS_INS_PART_IMG1_DISP_POS    0x80
#define TS_INS_PART_IMG1_START_AD    0x81
#define TS_INS_PART_IMG1_END_AD      0x82
#define TS_INS_PART_IMG2_DISP_POS    0x83
#define TS_INS_PART_IMG2_START_AD    0x84
#define TS_INS_PART_IMG2_END_AD      0x85
#define TS_INS_PANEL_IF_CTRL1        0x90
#define TS_INS_PANEL_IF_CTRL2        0x92
#define TS_INS_PANEL_IF_CTRL3        0x93
#define TS_INS_PANEL_IF_CTRL4        0x95
#define TS_INS_PANEL_IF_CTRL5        0x97
#define TS_INS_PANEL_IF_CTRL6        0x98           


#ifdef LANDSCAPE
#define TS_SIZE_X               320
#define TS_SIZE_Y               240
#define TS_VAL_ENTRY_MOD         0x0028
#define TS_INS_GRAM_ADX            TS_INS_GRAM_VER_AD
#define TS_INS_GRAM_ADY            TS_INS_GRAM_HOR_AD
#define TS_INS_START_ADX            TS_INS_VER_START_AD
#define TS_INS_END_ADX            TS_INS_VER_END_AD
#define TS_INS_START_ADY            TS_INS_HOR_START_AD
#define TS_INS_END_ADY            TS_INS_HOR_END_AD
#else
#define TS_SIZE_X                    240
#define TS_SIZE_Y                    320
#define TS_VAL_ENTRY_MOD             0x0030
#define TS_INS_GRAM_ADX              TS_INS_GRAM_HOR_AD
#define TS_INS_GRAM_ADY              TS_INS_GRAM_VER_AD
#define TS_INS_START_ADX             TS_INS_HOR_START_AD
#define TS_INS_END_ADX               TS_INS_HOR_END_AD
#define TS_INS_START_ADY             TS_INS_VER_START_AD
#define TS_INS_END_ADY               TS_INS_VER_END_AD
#endif


#define RED                  0x001F
#define GREEN                0x07E0
#define BLUE                 0xF800
#define YELLOW               0x07FF
#define PURPLE               0xF81F
#define BLACK                0x0000
#define WHITE                0xFFFF

#define red                  RED
#define green                GREEN
#define blue                 BLUE
#define yellow               YELLOW
#define purple               PURPLE
#define black                BLACK
#define white                WHITE



unsigned short int x_text=0,y_text=0;

const unsigned int font8x16[97][16]= 
{
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // space 0x20
0x00,0x00,0x18,0x3C,0x3C,0x3C,0x18,0x18,0x18,0x00,0x18,0x18,0x00,0x00,0x00,0x00, // !
0x00,0x63,0x63,0x63,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // "
0x00,0x00,0x00,0x36,0x36,0x7F,0x36,0x36,0x36,0x7F,0x36,0x36,0x00,0x00,0x00,0x00, // #
0x0C,0x0C,0x3E,0x63,0x61,0x60,0x3E,0x03,0x03,0x43,0x63,0x3E,0x0C,0x0C,0x00,0x00, // $
0x00,0x00,0x00,0x00,0x00,0x61,0x63,0x06,0x0C,0x18,0x33,0x63,0x00,0x00,0x00,0x00, // %
0x00,0x00,0x00,0x1C,0x36,0x36,0x1C,0x3B,0x6E,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // &
0x00,0x30,0x30,0x30,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // '
0x00,0x00,0x0C,0x18,0x18,0x30,0x30,0x30,0x30,0x18,0x18,0x0C,0x00,0x00,0x00,0x00, // (
0x00,0x00,0x18,0x0C,0x0C,0x06,0x06,0x06,0x06,0x0C,0x0C,0x18,0x00,0x00,0x00,0x00, // )
0x00,0x00,0x00,0x00,0x42,0x66,0x3C,0xFF,0x3C,0x66,0x42,0x00,0x00,0x00,0x00,0x00, // *
0x00,0x00,0x00,0x00,0x18,0x18,0x18,0xFF,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00, // +
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x00,0x00, // ,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // -
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00, // .
0x00,0x00,0x01,0x03,0x07,0x0E,0x1C,0x38,0x70,0xE0,0xC0,0x80,0x00,0x00,0x00,0x00, // / (forward slash)
0x00,0x00,0x3E,0x63,0x63,0x63,0x6B,0x6B,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // 0 0x30
0x00,0x00,0x0C,0x1C,0x3C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x3F,0x00,0x00,0x00,0x00, // 1
0x00,0x00,0x3E,0x63,0x03,0x06,0x0C,0x18,0x30,0x61,0x63,0x7F,0x00,0x00,0x00,0x00, // 2
0x00,0x00,0x3E,0x63,0x03,0x03,0x1E,0x03,0x03,0x03,0x63,0x3E,0x00,0x00,0x00,0x00, // 3
0x00,0x00,0x06,0x0E,0x1E,0x36,0x66,0x66,0x7F,0x06,0x06,0x0F,0x00,0x00,0x00,0x00, // 4
0x00,0x00,0x7F,0x60,0x60,0x60,0x7E,0x03,0x03,0x63,0x73,0x3E,0x00,0x00,0x00,0x00, // 5
0x00,0x00,0x1C,0x30,0x60,0x60,0x7E,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // 6
0x00,0x00,0x7F,0x63,0x03,0x06,0x06,0x0C,0x0C,0x18,0x18,0x18,0x00,0x00,0x00,0x00, // 7
0x00,0x00,0x3E,0x63,0x63,0x63,0x3E,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // 8
0x00,0x00,0x3E,0x63,0x63,0x63,0x63,0x3F,0x03,0x03,0x06,0x3C,0x00,0x00,0x00,0x00, // 9
0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00, // :
0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x00,0x00, // ;
0x00,0x00,0x00,0x06,0x0C,0x18,0x30,0x60,0x30,0x18,0x0C,0x06,0x00,0x00,0x00,0x00, // <
0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00, // =
0x00,0x00,0x00,0x60,0x30,0x18,0x0C,0x06,0x0C,0x18,0x30,0x60,0x00,0x00,0x00,0x00, // >
0x00,0x00,0x3E,0x63,0x63,0x06,0x0C,0x0C,0x0C,0x00,0x0C,0x0C,0x00,0x00,0x00,0x00, // ?
0x00,0x00,0x3E,0x63,0x63,0x6F,0x6B,0x6B,0x6E,0x60,0x60,0x3E,0x00,0x00,0x00,0x00, // @ 0x40
0x00,0x00,0x08,0x1C,0x36,0x63,0x63,0x63,0x7F,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // A
0x00,0x00,0x7E,0x33,0x33,0x33,0x3E,0x33,0x33,0x33,0x33,0x7E,0x00,0x00,0x00,0x00, // B
0x00,0x00,0x1E,0x33,0x61,0x60,0x60,0x60,0x60,0x61,0x33,0x1E,0x00,0x00,0x00,0x00, // C
0x00,0x00,0x7C,0x36,0x33,0x33,0x33,0x33,0x33,0x33,0x36,0x7C,0x00,0x00,0x00,0x00, // D
0x00,0x00,0x7F,0x33,0x31,0x34,0x3C,0x34,0x30,0x31,0x33,0x7F,0x00,0x00,0x00,0x00, // E
0x00,0x00,0x7F,0x33,0x31,0x34,0x3C,0x34,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // F
0x00,0x00,0x1E,0x33,0x61,0x60,0x60,0x6F,0x63,0x63,0x37,0x1D,0x00,0x00,0x00,0x00, // G
0x00,0x00,0x63,0x63,0x63,0x63,0x7F,0x63,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // H
0x00,0x00,0x3C,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,0x00,0x00, // I
0x00,0x00,0x0F,0x06,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3C,0x00,0x00,0x00,0x00, // J
0x00,0x00,0x73,0x33,0x36,0x36,0x3C,0x36,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00, // K
0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x31,0x33,0x7F,0x00,0x00,0x00,0x00, // L
0x00,0x00,0x63,0x77,0x7F,0x6B,0x63,0x63,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // M
0x00,0x00,0x63,0x63,0x73,0x7B,0x7F,0x6F,0x67,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // N
0x00,0x00,0x1C,0x36,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1C,0x00,0x00,0x00,0x00, // O
0x00,0x00,0x7E,0x33,0x33,0x33,0x3E,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // P 0x50
0x00,0x00,0x3E,0x63,0x63,0x63,0x63,0x63,0x63,0x6B,0x6F,0x3E,0x06,0x07,0x00,0x00, // Q
0x00,0x00,0x7E,0x33,0x33,0x33,0x3E,0x36,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00, // R
0x00,0x00,0x3E,0x63,0x63,0x30,0x1C,0x06,0x03,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // S
0x00,0x00,0xFF,0xDB,0x99,0x18,0x18,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,0x00,0x00, // T
0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // U
0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1C,0x08,0x00,0x00,0x00,0x00, // V
0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x6B,0x6B,0x7F,0x36,0x36,0x00,0x00,0x00,0x00, // W
0x00,0x00,0xC3,0xC3,0x66,0x3C,0x18,0x18,0x3C,0x66,0xC3,0xC3,0x00,0x00,0x00,0x00, // X
0x00,0x00,0xC3,0xC3,0xC3,0x66,0x3C,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,0x00,0x00, // Y
0x00,0x00,0x7F,0x63,0x43,0x06,0x0C,0x18,0x30,0x61,0x63,0x7F,0x00,0x00,0x00,0x00, // Z
0x00,0x00,0x3C,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x3C,0x00,0x00,0x00,0x00, // [
0x00,0x00,0x80,0xC0,0xE0,0x70,0x38,0x1C,0x0E,0x07,0x03,0x01,0x00,0x00,0x00,0x00, // \ (back slash)
0x00,0x00,0x3C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x3C,0x00,0x00,0x00,0x00, // ]
0x08,0x1C,0x36,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // ^
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00, // _
0x18,0x18,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // ` 0x60
0x00,0x00,0x00,0x00,0x00,0x3C,0x46,0x06,0x3E,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // a
0x00,0x00,0x70,0x30,0x30,0x3C,0x36,0x33,0x33,0x33,0x33,0x6E,0x00,0x00,0x00,0x00, // b
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x60,0x60,0x60,0x63,0x3E,0x00,0x00,0x00,0x00, // c
0x00,0x00,0x0E,0x06,0x06,0x1E,0x36,0x66,0x66,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // d
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x63,0x7E,0x60,0x63,0x3E,0x00,0x00,0x00,0x00, // e
0x00,0x00,0x1C,0x36,0x32,0x30,0x7C,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // f
0x00,0x00,0x00,0x00,0x00,0x3B,0x66,0x66,0x66,0x66,0x3E,0x06,0x66,0x3C,0x00,0x00, // g
0x00,0x00,0x70,0x30,0x30,0x36,0x3B,0x33,0x33,0x33,0x33,0x73,0x00,0x00,0x00,0x00, // h
0x00,0x00,0x0C,0x0C,0x00,0x1C,0x0C,0x0C,0x0C,0x0C,0x0C,0x1E,0x00,0x00,0x00,0x00, // i
0x00,0x00,0x06,0x06,0x00,0x0E,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3C,0x00,0x00, // j
0x00,0x00,0x70,0x30,0x30,0x33,0x33,0x36,0x3C,0x36,0x33,0x73,0x00,0x00,0x00,0x00, // k
0x00,0x00,0x1C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x1E,0x00,0x00,0x00,0x00, // l
0x00,0x00,0x00,0x00,0x00,0x6E,0x7F,0x6B,0x6B,0x6B,0x6B,0x6B,0x00,0x00,0x00,0x00, // m
0x00,0x00,0x00,0x00,0x00,0x6E,0x33,0x33,0x33,0x33,0x33,0x33,0x00,0x00,0x00,0x00, // n
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // o
0x00,0x00,0x00,0x00,0x00,0x6E,0x33,0x33,0x33,0x33,0x3E,0x30,0x30,0x78,0x00,0x00, // p 0x70
0x00,0x00,0x00,0x00,0x00,0x3B,0x66,0x66,0x66,0x66,0x3E,0x06,0x06,0x0F,0x00,0x00, // q
0x00,0x00,0x00,0x00,0x00,0x6E,0x3B,0x33,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // r
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x38,0x0E,0x03,0x63,0x3E,0x00,0x00,0x00,0x00, // s
0x00,0x00,0x08,0x18,0x18,0x7E,0x18,0x18,0x18,0x18,0x1B,0x0E,0x00,0x00,0x00,0x00, // t
0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // u
0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x36,0x36,0x1C,0x1C,0x08,0x00,0x00,0x00,0x00, // v
0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x6B,0x6B,0x7F,0x36,0x00,0x00,0x00,0x00, // w
0x00,0x00,0x00,0x00,0x00,0x63,0x36,0x1C,0x1C,0x1C,0x36,0x63,0x00,0x00,0x00,0x00, // x
0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x3F,0x03,0x06,0x3C,0x00,0x00, // y
0x00,0x00,0x00,0x00,0x00,0x7F,0x66,0x0C,0x18,0x30,0x63,0x7F,0x00,0x00,0x00,0x00, // z
0x00,0x00,0x0E,0x18,0x18,0x18,0x70,0x18,0x18,0x18,0x18,0x0E,0x00,0x00,0x00,0x00, // {
0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x00,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00, // |
0x00,0x00,0x70,0x18,0x18,0x18,0x0E,0x18,0x18,0x18,0x18,0x70,0x00,0x00,0x00,0x00, // }
0x00,0x00,0x3B,0x6E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // ~
0x00,0x70,0xD8,0xD8,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  // DEL
};  

//----------------------------------------------------------------------
void lcd_init(void);
void lcd_write_index_register(unsigned char ins);
void lcd_write_wdr(unsigned short  int data);
unsigned short int  lcd_read_rdr(void);
void lcd_clear_screen(void);
void lcd_background_color(unsigned short int color);
void lcd_write_pixel(unsigned short int x,unsigned short int y,unsigned short int color);
unsigned short int lcd_read_pixel(unsigned short int x,unsigned short int y);
void lcd_draw_line(unsigned short int x0,unsigned short int y0,
                 unsigned short int x1,unsigned short int y1,unsigned short int color) ;
void lcd_draw_rectangle(unsigned short int x0, unsigned short int y0, unsigned short int x1,
                      unsigned short int y1,unsigned char fill,unsigned short int color);
void lcd_draw_circle(unsigned short int x0,unsigned short int y0,unsigned short int radius,char fill,unsigned short int color) ;
//void lcd_write_pic(unsigned long x,unsigned long y,const unsigned *pointer);
void lcd_write_pic(int x0,int y0,const unsigned short *pointer);
void lcd_puts(unsigned short int x,unsigned short int y,char *string,unsigned short int forground_color,
           char background_color_activation,unsigned short int background_color,char size);
void lcd_putchar1608(char character,long forground_color,short background_color_activation,long background_color);
void lcd_putchar1616(char character,long forground_color,short background_color_activation,long background_color);
void lcd_putchar3216(char character,long forground_color,short background_color_activation,long background_color);
void lcd_gotoxy(unsigned short int x,unsigned short int y);
//-----------------------------------------------------------------------
   // send a word data to the lcd
//-----------------------------------------------------------------------
void lcd_write_index_register(unsigned char ins)
    {
   LPC_GPIO_TypeDef *pGPIO_CONTROL_PORT,*pGPIO_DATA_MSB_PORT,*pGPIO_DATA_LSB_PORT;
             #if (LCD_CONTROL_PORT==0)
                 pGPIO_CONTROL_PORT = GPIO0_Byte;
             #endif
             #if (LCD_CONTROL_PORT==1)
                 pGPIO_CONTROL_PORT = GPIO1_Byte;
             #endif
             #if (LCD_CONTROL_PORT==2)
                 pGPIO_CONTROL_PORT = GPIO2_Byte;
             #endif
             #if (LCD_CONTROL_PORT==3)
                 pGPIO_CONTROL_PORT = GPIO3_Byte;
             #endif
             #if (LCD_CONTROL_PORT==4)
                 pGPIO_CONTROL_PORT = GPIO4_Byte;
             #endif

             #if (LCD_DATA_MSB_PORT==0)
                 pGPIO_DATA_MSB_PORT = GPIO0_Byte;
             #endif
             #if (LCD_DATA_MSB_PORT==1)
                 pGPIO_DATA_MSB_PORT = GPIO1_Byte;
             #endif
             #if (LCD_DATA_MSB_PORT==2)
                 pGPIO_DATA_MSB_PORT = GPIO2_Byte;
             #endif
             #if (LCD_DATA_MSB_PORT==3)
                 pGPIO_DATA_MSB_PORT = GPIO3_Byte;
             #endif
             #if (LCD_DATA_MSB_PORT==4)
                 pGPIO_DATA_MSB_PORT = GPIO4_Byte;
             #endif

             #if (LCD_DATA_LSB_PORT==0)
                 pGPIO_DATA_LSB_PORT = GPIO0_Byte;
             #endif
             #if (LCD_DATA_lSB_PORT==1)
                 pGPIO_DATA_LSB_PORT = GPIO1_Byte;
             #endif
             #if (LCD_DATA_LSB_PORT==2)
                 pGPIO_DATA_LSB_PORT = GPIO2_Byte;
             #endif
             #if (LCD_DATA_LSB_PORT==3)
                 pGPIO_DATA_LSB_PORT = GPIO3_Byte;
             #endif
             #if (LCD_DATA_LSB_PORT==4)
                 pGPIO_DATA_LSB_PORT = GPIO4_Byte;
             #endif
    //CS_LOW;
    //RS_LOW;
                                pGPIO_CONTROL_PORT->FIOCLR=1<<LCD_CS;
                                pGPIO_CONTROL_PORT->FIOCLR=1<<LCD_RS;
    //LCD_DATAPORT_MSB_SET(0x00);
    //LCD_DATAPORT_LSB_SET(ins);
                                pGPIO_DATA_MSB_PORT->FIOCLR=0xFF<<LCD_DATA_MSB_PORT_OFFSET;
                                pGPIO_DATA_LSB_PORT->FIOSET=ins<<LCD_DATA_LSB_PORT_OFFSET;
    //WR_LOW;
    //WR_HIGH;
    //CS_HIGH;
                                pGPIO_CONTROL_PORT->FIOCLR=1<<LCD_WR;
                                pGPIO_CONTROL_PORT->FIOSET=1<<LCD_WR;
                                pGPIO_CONTROL_PORT->FIOSET=1<<LCD_CS;
    //LCD_DATAPORT_MSB_CLEAR(0x00);
    //LCD_DATAPORT_LSB_CLEAR(ins);
                                pGPIO_DATA_LSB_PORT->FIOCLR=0xFF<<LCD_DATA_LSB_PORT_OFFSET;
    }
   
//-----------------------------------------------------------------------
   // write a word data into the WDR lcd register
//-----------------------------------------------------------------------
void lcd_write_wdr(unsigned short  int data)
    { 
   LPC_GPIO_TypeDef *pGPIO_CONTROL_PORT,*pGPIO_DATA_MSB_PORT,*pGPIO_DATA_LSB_PORT;
                #if (LCD_CONTROL_PORT==0)
                    pGPIO_CONTROL_PORT = GPIO0_Byte;
                #endif
                #if (LCD_CONTROL_PORT==1)
                    pGPIO_CONTROL_PORT = GPIO1_Byte;
                #endif
                #if (LCD_CONTROL_PORT==2)
                    pGPIO_CONTROL_PORT = GPIO2_Byte;
                #endif
                #if (LCD_CONTROL_PORT==3)
                    pGPIO_CONTROL_PORT = GPIO3_Byte;
                #endif
                #if (LCD_CONTROL_PORT==4)
                    pGPIO_CONTROL_PORT = GPIO4_Byte;
                #endif

                #if (LCD_DATA_MSB_PORT==0)
                    pGPIO_DATA_MSB_PORT = GPIO0_Byte;
                #endif
                #if (LCD_DATA_MSB_PORT==1)
                    pGPIO_DATA_MSB_PORT = GPIO1_Byte;
                #endif
                #if (LCD_DATA_MSB_PORT==2)
                    pGPIO_DATA_MSB_PORT = GPIO2_Byte;
                #endif
                #if (LCD_DATA_MSB_PORT==3)
                    pGPIO_DATA_MSB_PORT = GPIO3_Byte;
                #endif
                #if (LCD_DATA_MSB_PORT==4)
                    pGPIO_DATA_MSB_PORT = GPIO4_Byte;
                #endif

                #if (LCD_DATA_LSB_PORT==0)
                    pGPIO_DATA_LSB_PORT = GPIO0_Byte;
                #endif
                #if (LCD_DATA_lSB_PORT==1)
                    pGPIO_DATA_LSB_PORT = GPIO1_Byte;
                #endif
                #if (LCD_DATA_LSB_PORT==2)
                    pGPIO_DATA_LSB_PORT = GPIO2_Byte;
                #endif
                #if (LCD_DATA_LSB_PORT==3)
                    pGPIO_DATA_LSB_PORT = GPIO3_Byte;
                #endif
                #if (LCD_DATA_LSB_PORT==4)
                    pGPIO_DATA_LSB_PORT = GPIO4_Byte;
                #endif
    //CS_LOW;
    //RS_HIGH;
                                                  pGPIO_CONTROL_PORT->FIOCLR=1<<LCD_CS;
                                                    pGPIO_CONTROL_PORT->FIOSET=1<<LCD_RS;
    //LCD_DATAPORT_MSB_SET(data>>8);
    //LCD_DATAPORT_LSB_SET(data&0x00ff);
                                                    pGPIO_DATA_MSB_PORT->FIOSET=(data>>8)<<LCD_DATA_MSB_PORT_OFFSET;
                                                    pGPIO_DATA_LSB_PORT->FIOSET=(data&0x00ff)<<LCD_DATA_LSB_PORT_OFFSET;
    //WR_LOW;
    //WR_HIGH;
    //CS_HIGH;
                                                    pGPIO_CONTROL_PORT->FIOCLR=1<<LCD_WR;
                                                    pGPIO_CONTROL_PORT->FIOSET=1<<LCD_WR;
                                                    pGPIO_CONTROL_PORT->FIOSET=1<<LCD_CS;
    //LCD_DATAPORT_MSB_CLEAR(data>>8);
    //LCD_DATAPORT_LSB_CLEAR(data&0xff);
                                                    pGPIO_DATA_MSB_PORT->FIOCLR=0xff<<LCD_DATA_MSB_PORT_OFFSET;
                                                    pGPIO_DATA_LSB_PORT->FIOCLR=0xff<<LCD_DATA_LSB_PORT_OFFSET;
    }
   
//-----------------------------------------------------------------------
   // read data from rdr lcd register
//-----------------------------------------------------------------------
unsigned short int  lcd_read_rdr(void)
    { 
    unsigned char            data_lsb,data_msb;
    unsigned short  int      rdr_data;  
    //LCD_DATAPORT_CLEAR;
    LCD_DATAPORT_INPUT;
    RD_LOW;
   WR_HIGH;
   CS_LOW;
    data_lsb=LCD_DATAPORT_LSB_PIN;
    data_msb=LCD_DATAPORT_MSB_PIN;
    rdr_data=data_msb;
    rdr_data<<=8;
    rdr_data|=data_lsb;
    CS_HIGH;
    RD_HIGH;
   LCD_DATAPORT_OUTPUT;
    return rdr_data;
    }
//-----------------------------------------------------------------------
   // clears the lcd panel
//-----------------------------------------------------------------------
void lcd_clear_screen(void)
    {  
       lcd_background_color(WHITE);
    }
//-----------------------------------------------------------------------
   // set background color
//-----------------------------------------------------------------------
void lcd_background_color(unsigned short int color)
    {  
    long counter;
    unsigned int data;
    LPC_GPIO_TypeDef *pGPIO_CONTROL_PORT,*pGPIO_DATA_MSB_PORT,*pGPIO_DATA_LSB_PORT;
          #if (LCD_CONTROL_PORT==0)
              pGPIO_CONTROL_PORT = GPIO0_Byte;
          #endif
          #if (LCD_CONTROL_PORT==1)
              pGPIO_CONTROL_PORT = GPIO1_Byte;
          #endif
          #if (LCD_CONTROL_PORT==2)
              pGPIO_CONTROL_PORT = GPIO2_Byte;
          #endif
          #if (LCD_CONTROL_PORT==3)
              pGPIO_CONTROL_PORT = GPIO3_Byte;
          #endif
          #if (LCD_CONTROL_PORT==4)
              pGPIO_CONTROL_PORT = GPIO4_Byte;
          #endif

          #if (LCD_DATA_MSB_PORT==0)
              pGPIO_DATA_MSB_PORT = GPIO0_Byte;
          #endif
          #if (LCD_DATA_MSB_PORT==1)
              pGPIO_DATA_MSB_PORT = GPIO1_Byte;
          #endif
          #if (LCD_DATA_MSB_PORT==2)
              pGPIO_DATA_MSB_PORT = GPIO2_Byte;
          #endif
          #if (LCD_DATA_MSB_PORT==3)
              pGPIO_DATA_MSB_PORT = GPIO3_Byte;
          #endif
          #if (LCD_DATA_MSB_PORT==4)
              pGPIO_DATA_MSB_PORT = GPIO4_Byte;
          #endif

          #if (LCD_DATA_LSB_PORT==0)
              pGPIO_DATA_LSB_PORT = GPIO0_Byte;
          #endif
          #if (LCD_DATA_lSB_PORT==1)
              pGPIO_DATA_LSB_PORT = GPIO1_Byte;
          #endif
          #if (LCD_DATA_LSB_PORT==2)
              pGPIO_DATA_LSB_PORT = GPIO2_Byte;
          #endif
          #if (LCD_DATA_LSB_PORT==3)
              pGPIO_DATA_LSB_PORT = GPIO3_Byte;
          #endif
          #if (LCD_DATA_LSB_PORT==4)
              pGPIO_DATA_LSB_PORT = GPIO4_Byte;
          #endif
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(0);             
    lcd_write_index_register(TS_INS_START_ADX);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_START_ADY);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_END_ADX);
    #ifdef PORTRAIT
    lcd_write_wdr(239);
    #else
    lcd_write_wdr(319); 
    #endif
    lcd_write_index_register(TS_INS_END_ADY);
    #ifdef PORTRAIT
    lcd_write_wdr(319);
    #else
    lcd_write_wdr(239); 
    #endif 
    lcd_write_index_register(TS_INS_RW_GRAM);
    CS_LOW;
    RS_HIGH;
    data=color;
    //LCD_DATAPORT_MSB_SET(data>>8);
    //LCD_DATAPORT_LSB_SET(data&0x00ff);
                                        pGPIO_DATA_MSB_PORT->FIOSET  = (data>>8)<<LCD_DATA_MSB_PORT_OFFSET;
                                                               pGPIO_DATA_LSB_PORT->FIOSET  = (data&0x00ff)<<LCD_DATA_LSB_PORT_OFFSET;
    for(counter=0;counter<76800;counter++)
    {
          //WR_LOW;
                                     pGPIO_CONTROL_PORT->FIOCLR  = 1<<LCD_WR;
          //WR_HIGH;
                                     pGPIO_CONTROL_PORT->FIOSET  = 1<<LCD_WR;
    }
    //LCD_DATAPORT_CLEAR;
                                     pGPIO_DATA_MSB_PORT->FIOCLR  = (0xff)<<LCD_DATA_MSB_PORT_OFFSET;
                                                           pGPIO_DATA_LSB_PORT->FIOCLR  = (0xff)<<LCD_DATA_LSB_PORT_OFFSET;
    CS_HIGH;
}
//-----------------------------------------------------------------------   
   // lcd initialization
//-----------------------------------------------------------------------   
void lcd_init(void)
{
        GPIO_SetDir(LCD_CONTROL_PORT,(1<<LCD_CS)|(1<<LCD_RS)|(1<<LCD_WR)|(1<<LCD_RD)|(1<<LCD_RST),1);
       LCD_DATAPORT_OUTPUT;
       RST_HIGH;
       RS_HIGH;
       CS_HIGH;
       RD_HIGH;
       WR_HIGH;
    // reset lcd chipset
    //LCD_RST_PORT.LCD_RST_PIN=LOW;
    RST_LOW;
    delay_ms(1);           
    //LCD_RST_PORT.LCD_RST_PIN=HIGH;
    RST_HIGH;          
    lcd_write_index_register(0x00E3);
    lcd_write_wdr(0x3008);                     //set the internal timing
    lcd_write_index_register(0x00E7);
    lcd_write_wdr(0x0012);                     //set the internal timing
    lcd_write_index_register(0x00EF);
    lcd_write_wdr(0x1231);                     //set the internal timing
    lcd_write_index_register(TS_INS_START_OSC);
    lcd_write_wdr(0x0001);                     //start oscillator
    //if(lcd_read_rdr()==0x9325) {DDRB.7=1;PORTB.7=1;}
    delay_ms(50);

    lcd_write_index_register(TS_INS_DRIV_OUT_CTRL);
    ///////////////////////////////////////////////////////////////////////////lcd_write_wdr(0x0100);                     //set SS, SM
    lcd_write_wdr(0x0000);
   //lcd_write_wdr(0x0400);
   //lcd_write_wdr(0x0500);
    lcd_write_index_register(TS_INS_DRIV_WAV_CTRL);
    lcd_write_wdr(0x0700);                     //set 1 line inversion
    lcd_write_index_register(TS_INS_ENTRY_MOD);
    lcd_write_wdr(TS_VAL_ENTRY_MOD);            //set GRAM write direction, BGR=0

    lcd_write_index_register(TS_INS_RESIZE_CTRL);
    lcd_write_wdr(0x0000);                     //no resizing

    lcd_write_index_register(TS_INS_DISP_CTRL2);
    lcd_write_wdr(0x0202);                     //front & back porch periods = 2
    lcd_write_index_register(TS_INS_DISP_CTRL3);
    lcd_write_wdr(0x0000);                     
    lcd_write_index_register(TS_INS_DISP_CTRL4);
    lcd_write_wdr(0x0000);                     
    lcd_write_index_register(TS_INS_RGB_DISP_IF_CTRL1);
    lcd_write_wdr(0x0000);                     //select system interface                
    lcd_write_index_register(TS_INS_FRM_MARKER_POS);
    lcd_write_wdr(0x0000);                     
    lcd_write_index_register(TS_INS_RGB_DISP_IF_CTRL2);
    lcd_write_wdr(0x0000);                    
    
    lcd_write_index_register(TS_INS_POW_CTRL1);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_POW_CTRL2);
    lcd_write_wdr(0x0007);                     
    lcd_write_index_register(TS_INS_POW_CTRL3);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_POW_CTRL4);
    lcd_write_wdr(0x0000);                     
    delay_ms(200);

    lcd_write_index_register(TS_INS_POW_CTRL1);
    lcd_write_wdr(0x1690);
    lcd_write_index_register(TS_INS_POW_CTRL2);
    lcd_write_wdr(0x0007); //lcd_write_wdr(0x0137);
    delay_ms(50);

    lcd_write_index_register(TS_INS_POW_CTRL3);
    lcd_write_wdr(0x011A);
    ///////////////////////////////////////////////////////////////////////////////////////////////////lcd_write_wdr(0x013C);
    delay_ms(50);

    lcd_write_index_register(TS_INS_POW_CTRL4);
    lcd_write_wdr(0x1800); //lcd_write_wdr(0x1400);
    lcd_write_index_register(TS_INS_POW_CTRL7);
    lcd_write_wdr(0x002A); //lcd_write_wdr(0x0007);
    delay_ms(50);

    lcd_write_index_register(TS_INS_GRAM_HOR_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GRAM_VER_AD);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_GAMMA_CTRL1);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL2);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL3);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL4);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL5);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL6);
    lcd_write_wdr(0x0406);
    lcd_write_index_register(TS_INS_GAMMA_CTRL7);
    lcd_write_wdr(0x0006);
    lcd_write_index_register(TS_INS_GAMMA_CTRL8);
    lcd_write_wdr(0x0404);
    lcd_write_index_register(TS_INS_GAMMA_CTRL9);
    lcd_write_wdr(0x0700);
    lcd_write_index_register(TS_INS_GAMMA_CTRL10);
    lcd_write_wdr(0x0A08);

    lcd_write_index_register(TS_INS_HOR_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_HOR_END_AD);
    lcd_write_wdr(0x00EF);
    lcd_write_index_register(TS_INS_VER_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_VER_END_AD);
    lcd_write_wdr(0x013F);
    lcd_write_index_register(TS_INS_GATE_SCAN_CTRL1);
    lcd_write_wdr(0xA700);
    lcd_write_index_register(TS_INS_GATE_SCAN_CTRL2);
    lcd_write_wdr(0x0001);
    lcd_write_index_register(TS_INS_GATE_SCAN_CTRL3);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_PART_IMG1_DISP_POS);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG1_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG1_END_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG2_DISP_POS);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG2_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG2_END_AD);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_PANEL_IF_CTRL1);
    lcd_write_wdr(0x0010);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL2);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL3);
    lcd_write_wdr(0x0003);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL4);
    lcd_write_wdr(0x0110);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL5);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL6);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_DISP_CTRL1);
    lcd_write_wdr(0x0133);
    
    lcd_write_index_register(TS_INS_FRM_RATE_COL_CTRL);
    lcd_write_wdr(0x000D);
    delay_ms(50);
    lcd_clear_screen();
        delay_ms(100);
}
//-----------------------------------------------------------------------
   // turn on a pixel on the lcd screen
//-----------------------------------------------------------------------
void lcd_write_pixel(unsigned short int x,unsigned short int y,unsigned short int color)
    { 
    #ifdef LANDSCAPE
    y=239-y;
    #endif
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(x); 
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_START_ADX);
    lcd_write_wdr(x);
    lcd_write_index_register(TS_INS_END_ADX);
    lcd_write_wdr(x);
    lcd_write_index_register(TS_INS_START_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_END_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_RW_GRAM);
    lcd_write_wdr(color);
    }
//-----------------------------------------------------------------------
   // Read A Pixel Color On The LCD Screen
//-----------------------------------------------------------------------
unsigned short int lcd_read_pixel(unsigned short int x,unsigned short int y)
    { 
      unsigned short int pixel;
    #ifdef LANDSCAPE
    //y=239-y;
    #endif

    delay_us(10);
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(x); 
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_START_ADX);
    lcd_write_wdr(x);
    lcd_write_index_register(TS_INS_END_ADX);
    lcd_write_wdr(x); 
    lcd_write_index_register(TS_INS_START_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_END_ADY);
    lcd_write_wdr(y); 
    delay_us(10);
    lcd_write_index_register(TS_INS_RW_GRAM);
    //delay_us(10);
    pixel=lcd_read_rdr();
    //delay_us(10);
    return pixel;
    }

//-----------------------------------------------------------------------
   // draw a line with x0,y0 and x1,y1 coordinates
//-----------------------------------------------------------------------   
void lcd_draw_line(unsigned short int x0,unsigned short int y0,unsigned short int x1,unsigned short int y1,unsigned short int color) 
    {
    signed short int dy;
    signed short int dx;
    signed short int fraction;
    unsigned short int stepx,stepy;
    dy=y1-y0;
    dx=x1-x0;
    if(dy<0) {dy=-dy;stepy=-1;} else {stepy=1;}
    if(dx<0) {dx=-dx;stepx=-1;} else {stepx=1;}
    dy<<=1; 
    dx<<=1; 
    lcd_write_pixel(x0,y0,color);
    if(dx>dy) 
      {
      fraction=dy-(dx>>1); 
      while(x0!=x1) 
        {
        if(fraction>=0) 
          {
          y0+=stepy;
          fraction-=dx; 
          }
        x0+=stepx;
        fraction+=dy; 
        lcd_write_pixel(x0,y0,color);
        }
      } 
    else 
      {
      fraction=dx-(dy>>1);
      while (y0 != y1) 
        {
        if(fraction>=0) 
          {
          x0+=stepx;
          fraction-=dy;
          }
        y0+=stepy;
        fraction+=dx;
        lcd_write_pixel(x0,y0,color);
        }
      }
    }
//-----------------------------------------------------------------------
   // draw a fill(1) or no fill(0) rectangular with specified color    
//-----------------------------------------------------------------------   
void lcd_draw_rectangle(unsigned short int x0, unsigned short int y0, unsigned short int x1
                     , unsigned short int y1,unsigned char fill,unsigned short int color)
    { 
    if(fill)
      {
            unsigned short int counter_x; 
            unsigned short int counter_y; 
#ifdef PORTRAIT
            lcd_write_index_register(TS_INS_GRAM_ADX);
            lcd_write_wdr(x0);
            lcd_write_index_register(TS_INS_GRAM_ADY);
            lcd_write_wdr(y0);  
            lcd_write_index_register(TS_INS_START_ADX);
            lcd_write_wdr(x0);
            lcd_write_index_register(TS_INS_END_ADX);
            lcd_write_wdr(x1);
            lcd_write_index_register(TS_INS_START_ADY);
            lcd_write_wdr(y0);
            lcd_write_index_register(TS_INS_END_ADY);
            lcd_write_wdr(y1); 
            lcd_write_index_register(TS_INS_RW_GRAM);
            for(counter_y=y0;counter_y<=y1;counter_y++)
            {
              for(counter_x=x0;counter_x<=x1;counter_x++)
                lcd_write_wdr(color);

                //lcd_write_pixel(counter_x,counter_y,color);
            }
#endif
#ifdef LANDSCAPE
    y0=239-y0;
    y1=239-y1;
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(x0);
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(y1);             
    lcd_write_index_register(TS_INS_START_ADX);
    lcd_write_wdr(x0);
    lcd_write_index_register(TS_INS_END_ADX);
    lcd_write_wdr(x1);
    lcd_write_index_register(TS_INS_START_ADY);
    lcd_write_wdr(y1);
    lcd_write_index_register(TS_INS_END_ADY);
    lcd_write_wdr(y0);
    lcd_write_index_register(TS_INS_RW_GRAM);
    for(counter_y=y1;counter_y<=y0;counter_y++)
   {
     for(counter_x=x0;counter_x<=x1;counter_x++)
       lcd_write_wdr(color);
   }
#endif
      } 

    else
      {
            lcd_draw_line(x0,y0,x1,y0,color);
            lcd_draw_line(x1,y0,x1,y1,color);
            lcd_draw_line(x1,y1,x0,y1,color); 
            lcd_draw_line(x0,y1,x0,y0,color);
      }
 }
//-----------------------------------------------------------------------
   // draw a fill(1) or no fill(0) circle with specified color 
//-----------------------------------------------------------------------   
void lcd_draw_circle(unsigned short int x0,unsigned short int y0,unsigned short int radius,char fill,unsigned short int color) 
    { 
    signed short int  x_offset,y_offset,error;
    x_offset=0; 
    y_offset=radius; 
    error=1-radius; 

    do 
      { 
      if(fill) 
        { 
        lcd_draw_line(x0-x_offset,y0+y_offset,x0+x_offset,y0+y_offset,color); 
        lcd_draw_line(x0-x_offset,y0-y_offset,x0+x_offset,y0-y_offset,color); 
        lcd_draw_line(x0-y_offset,y0+x_offset,x0+y_offset,y0+x_offset,color); 
        lcd_draw_line(x0-y_offset,y0-x_offset,x0+y_offset,y0-x_offset,color); 
        } 
      else 
        { 
        lcd_write_pixel(x_offset+x0,y_offset+y0,color); 
        lcd_write_pixel(y_offset+x0,x_offset+y0,color); 
        lcd_write_pixel(x0-x_offset,y_offset+y0,color); 
        lcd_write_pixel(x0-y_offset,x_offset+y0,color); 
        lcd_write_pixel(y_offset+x0,y0-x_offset,color); 
        lcd_write_pixel(x_offset+x0,y0-y_offset,color); 
        lcd_write_pixel(x0-x_offset,y0-y_offset,color); 
        lcd_write_pixel(x0-y_offset,y0-x_offset,color); 
        } 

      if(error<0) 
        error+=(3+(2*(x_offset++))); 
      else 
        error+=(5+(2*((x_offset++)-(y_offset--)))); 
      }while(x_offset<=y_offset); 
    } 

//-----------------------------------------------------------------------
   // Show A Picture On The LCD Screen
   //DAR IN GHESMAT BAYEST HATMAN DAR EBTEDAYE ARRAY TASWIR   BE ONVANE AVALIN ADADHA   EBTEDA TEDAD SATR VA SEPAS
   //TEDAD SOTOON NEVESHTE SHAVAD MASSALAN INGOONE
   //UNSIGNED SHORT PICTUR[]={
   //                     320,240,.....}BARAYE  LANDSCAP VA
   //UNSIGNED SHORT PICTUR[]={
   //                     240,320,.....}BARAYE  PORTRAIT
//-----------------------------------------------------------------------
void lcd_write_pic(int x0,int y0,const unsigned short *pointer)
    {
       unsigned long int counter;
       unsigned int data;
       LPC_GPIO_TypeDef *pGPIO_CONTROL_PORT,*pGPIO_DATA_MSB_PORT,*pGPIO_DATA_LSB_PORT;
      #if (LCD_CONTROL_PORT==0)
          pGPIO_CONTROL_PORT = GPIO0_Byte;
      #endif
      #if (LCD_CONTROL_PORT==1)
          pGPIO_CONTROL_PORT = GPIO1_Byte;
      #endif
      #if (LCD_CONTROL_PORT==2)
          pGPIO_CONTROL_PORT = GPIO2_Byte;
      #endif
      #if (LCD_CONTROL_PORT==3)
          pGPIO_CONTROL_PORT = GPIO3_Byte;
      #endif
      #if (LCD_CONTROL_PORT==4)
          pGPIO_CONTROL_PORT = GPIO4_Byte;
      #endif

      #if (LCD_DATA_MSB_PORT==0)
          pGPIO_DATA_MSB_PORT = GPIO0_Byte;
      #endif
      #if (LCD_DATA_MSB_PORT==1)
          pGPIO_DATA_MSB_PORT = GPIO1_Byte;
      #endif
      #if (LCD_DATA_MSB_PORT==2)
          pGPIO_DATA_MSB_PORT = GPIO2_Byte;
      #endif
      #if (LCD_DATA_MSB_PORT==3)
          pGPIO_DATA_MSB_PORT = GPIO3_Byte;
      #endif
      #if (LCD_DATA_MSB_PORT==4)
          pGPIO_DATA_MSB_PORT = GPIO4_Byte;
      #endif

      #if (LCD_DATA_LSB_PORT==0)
          pGPIO_DATA_LSB_PORT = GPIO0_Byte;
      #endif
      #if (LCD_DATA_lSB_PORT==1)
          pGPIO_DATA_LSB_PORT = GPIO1_Byte;
      #endif
      #if (LCD_DATA_LSB_PORT==2)
          pGPIO_DATA_LSB_PORT = GPIO2_Byte;
      #endif
      #if (LCD_DATA_LSB_PORT==3)
          pGPIO_DATA_LSB_PORT = GPIO3_Byte;
      #endif
      #if (LCD_DATA_LSB_PORT==4)
          pGPIO_DATA_LSB_PORT = GPIO4_Byte;
      #endif

        #ifdef PORTRAIT
       lcd_write_index_register(TS_INS_GRAM_ADX);
       lcd_write_wdr(0);
       lcd_write_index_register(TS_INS_START_ADX);
       lcd_write_wdr(0);
       lcd_write_index_register(TS_INS_END_ADX);
        lcd_write_wdr(239);
        lcd_write_index_register(TS_INS_GRAM_ADY);
        lcd_write_wdr(0);
        lcd_write_index_register(TS_INS_START_ADY);
        lcd_write_wdr(0);
        lcd_write_index_register(TS_INS_END_ADY);
        lcd_write_wdr(319);
        #else
        lcd_write_index_register(TS_INS_GRAM_ADX);
        lcd_write_wdr(0);
        lcd_write_index_register(TS_INS_START_ADX);
        lcd_write_wdr(0);
        lcd_write_index_register(TS_INS_END_ADX);
        lcd_write_wdr(319);
        lcd_write_index_register(TS_INS_GRAM_ADY);
        lcd_write_wdr(0);
        lcd_write_index_register(TS_INS_START_ADY);
        lcd_write_wdr(0);
        lcd_write_index_register(TS_INS_END_ADY);
        lcd_write_wdr(239);
        #endif
        lcd_write_index_register(TS_INS_RW_GRAM);
        CS_LOW;
        RS_HIGH;
        for(counter=0;counter<76800;counter++)
        {
          //lcd_write_wdr(*pointer++);
               data=*pointer++;
              //LCD_DATAPORT_MSB_SET(data>>8);
              pGPIO_DATA_MSB_PORT->FIOSET  = (data>>8)<<LCD_DATA_MSB_PORT_OFFSET;
              //LCD_DATAPORT_LSB_SET(data&0x00ff);
               pGPIO_DATA_LSB_PORT->FIOSET  = (data&0x00ff)<<LCD_DATA_LSB_PORT_OFFSET;
              //WR_LOW;
              pGPIO_CONTROL_PORT->FIOCLR  = 1<<LCD_WR;
              //WR_HIGH;
              pGPIO_CONTROL_PORT->FIOSET  = 1<<LCD_WR;
              //LCD_DATAPORT_CLEAR;
              pGPIO_DATA_MSB_PORT->FIOCLR  = (0xff)<<LCD_DATA_MSB_PORT_OFFSET;
              pGPIO_DATA_LSB_PORT->FIOCLR  = (0xff)<<LCD_DATA_LSB_PORT_OFFSET;
        }
        CS_HIGH;
     }
//-----------------------------------------------------------------------    
   // This Functions Goes The Cursor To X And Y Positions
//-----------------------------------------------------------------------    
void lcd_gotoxy(unsigned short int x,unsigned short int y)
{
   #ifdef LANDSCAPE
      if(x>319)
         x=0;
      if(y>239)
         y=0;
         x_text=x;
         y_text=y;
   #else
   if(x>239)
         x=0;
      if(y>319)
         y=0;
         x_text=x;
         y_text=y;
   #endif
}


//-----------------------------------------------------------------------   
   // Puts A Character On The LCD Screen
//-----------------------------------------------------------------------   
void lcd_putchar1608(char character,long forground_color,short background_color_activation,long background_color)
    {  
    unsigned short int temporary_color;
    unsigned char width_counter,length_counter;
    unsigned char character_segment_data;
    for(length_counter=0;length_counter<16;length_counter++)
        {
        character_segment_data=font8x16[character-0x20][length_counter];
        for(width_counter=0;width_counter<8;width_counter++)
            {
            if(character_segment_data&(0b10000000>>width_counter)) 
              lcd_write_pixel(x_text+width_counter,y_text+length_counter,forground_color);
            else 
              {
              if(background_color_activation)
                {
                //temporary_color=lcd_read_rdr();
                temporary_color=lcd_read_rdr();
                lcd_write_wdr(temporary_color);
                } 
              else
                lcd_write_pixel(x_text+width_counter,y_text+length_counter,background_color);
              }            
            }
        }
#ifdef LANDSCAPE
   x_text+=8;
   if(x_text>319)
  {            
     x_text=0;
     y_text+=16;
     if(y_text>239)
      y_text=0;
  }
#else
   x_text+=8;
   if(x_text>239)
        {            
        x_text=0;
        y_text+=16;
        if(y_text>319)
         y_text=0;
        }
#endif
    }
//-----------------------------------------------------------------------
void lcd_putchar1616(char character,long forground_color,short background_color_activation,long background_color)
    {  
    unsigned short int temporary_color;
    unsigned char width_counter,length_counter;
    unsigned char character_segment_data;
    for(length_counter=0;length_counter<16;length_counter++)
        {
        character_segment_data=font8x16[character-0x20][length_counter];
        for(width_counter=0;width_counter<16;width_counter+=2)
            {
            if(character_segment_data&(0b10000000>>(width_counter/2))) 
            {
              lcd_write_pixel(x_text+width_counter,y_text+length_counter,forground_color);
              lcd_write_pixel(x_text+width_counter+1,y_text+length_counter,forground_color);
            }
            else 
              {
              if(background_color_activation)
                {
                temporary_color=lcd_read_rdr();
                temporary_color=lcd_read_rdr();
                lcd_write_wdr(temporary_color);
                lcd_write_wdr(temporary_color);
                } 
              else
              {
                lcd_write_pixel(x_text+width_counter,y_text+length_counter,background_color);
                lcd_write_pixel(x_text+width_counter+1,y_text+length_counter,background_color);
              }            
            }
            }
        }
#ifdef LANDSCAPE
   x_text+=16;
   if(x_text>319)
        {            
        x_text=0;
        y_text+=16;
        if(y_text>239)
         y_text=0;
        }
#else
   x_text+=16;
   if(x_text>239)
        {            
        x_text=0;
        y_text+=16;
        if(y_text>319)
         y_text=0;
        }
#endif
    }
//-----------------------------------------------------------------------
void lcd_putchar3216(char character,long forground_color,short background_color_activation,long background_color)
    {  
    unsigned short int temporary_color;
    unsigned char width_counter,length_counter;
    unsigned char character_segment_data;
    for(length_counter=0;length_counter<32;length_counter+=2)
        {
        character_segment_data=font8x16[character-0x20][length_counter/2];
        for(width_counter=0;width_counter<16;width_counter+=2)
            {
            if(character_segment_data&(0b10000000>>(width_counter/2))) 
            {
                lcd_write_pixel(x_text+width_counter,y_text+length_counter,forground_color);
                lcd_write_pixel(x_text+width_counter+1,y_text+length_counter,forground_color);
                lcd_write_pixel(x_text+width_counter,y_text+length_counter+1,forground_color);
                lcd_write_pixel(x_text+width_counter+1,y_text+length_counter+1,forground_color);
            }
            else 
              {
              if(background_color_activation)
                {
                temporary_color=lcd_read_rdr();
                //temporary_color=lcd_read_rdr();
                lcd_write_wdr(temporary_color);
                lcd_write_wdr(temporary_color);
                lcd_write_wdr(temporary_color);
                } 
              else
                lcd_write_pixel(x_text+width_counter,y_text+length_counter,background_color);
                lcd_write_pixel(x_text+width_counter+1,y_text+length_counter,background_color);
                lcd_write_pixel(x_text+width_counter,y_text+length_counter+1,background_color);
                lcd_write_pixel(x_text+width_counter+1,y_text+length_counter+1,background_color);
              }            
            }
        }
#ifdef LANDSCAPE
   x_text+=16;
   if(x_text>319)
        {            
        x_text=0;
        y_text+=32;
        if(y_text>239)
         y_text=0;
        }
#else
   x_text+=16;
   if(x_text>239)
        {            
        x_text=0;
        y_text+=32;
        if(y_text>319)
         y_text=0;
        }
#endif
 }
//--------------------------------------------------------------------

//-----------------------------------------------------------------------   
   // Show A String That Stored In The Flash Memory Of The Microcontroller  
//-----------------------------------------------------------------------   
/*void lcd_putsf(flash char *string,int forground_color,char background_color_activation,int background_color)
    {
    while(*string)
      lcd_putchar(*string++,forground_color,background_color_activation,background_color);
    }*/
//-----------------------------------------------------------------------   
   // Show A String That Stored In The SRAM Of The Microcontroller    
//-----------------------------------------------------------------------   
void lcd_puts(unsigned short int x,unsigned short int y,char *string,unsigned short int forground_color,
           char background_color_activation,unsigned short int background_color,char size)
    {
       lcd_gotoxy(x,y);
       switch(size)
       {
         case 1:
               while(*string)
                     lcd_putchar1608(*string++,forground_color,background_color_activation,background_color);
               break;
         case 2:
               while(*string)
                     lcd_putchar1616(*string++,forground_color,background_color_activation,background_color);
               break;
         case 3:
               while(*string)
                     lcd_putchar3216(*string++,forground_color,background_color_activation,background_color);
               break;
       }
    }
//---------------------------------------
#endif
